// slice_by_2.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <stdio.h>

int main(int argc, char* argv[])
{
	FILE *stream_in, *stream_out, *stream_out_fast;
	errno_t err_in, err_out, err_out_fast;
	bool bTrigger = 0;
	uint32_t filelen;
	uint8_t *buffer;
	uint32_t uiPtr;
	uint8_t ui8Quaters;

	if (argc != 4)
	{
		printf("Usage is slice_by_2.exe <filename_in> <fast_filename_out> <normal_filename_out>\r\n");
	}
	else
	{
		err_in = fopen_s(&stream_in, argv[1], "r");
		err_out = fopen_s(&stream_out, argv[3], "w");
		err_out_fast = fopen_s(&stream_out_fast, argv[2], "w");

		if (err_in != 0 || err_out != 0 || err_out_fast != 0)
		{
			printf("Cannot open input or output file\r\n");
		}
		else
		{
			fseek(stream_in, 0, SEEK_END);          // Jump to the end of the file
			filelen = ftell(stream_in);             // Get the current byte offset in the file
			rewind(stream_in);                      // Jump back to the beginning of the file

			buffer = (uint8_t*)malloc(filelen * sizeof(uint8_t)); // Enough memory for the file
			fread(buffer, filelen, 1, stream_in); // Read in the entire file
			fclose(stream_in); // Close the file
			ui8Quaters = 0;
			for (uiPtr = 0; uiPtr < filelen; uiPtr++)
			{
				if (uiPtr > 43)
				{
					if (buffer[uiPtr] < 0x10)
					{
						buffer[uiPtr] = 0x00;
					}
					//slow speed
					fputc(buffer[uiPtr], stream_out);
					fputc(buffer[uiPtr], stream_out);
					//fast speed
					if (ui8Quaters == 0)
					{
						fputc(buffer[uiPtr], stream_out_fast);
						ui8Quaters++;
					}
					else
					{
						if (ui8Quaters == 3)
						{
							ui8Quaters = 0;
						}
						else
						{
							ui8Quaters++;
						}
					}
				}
			}
			_fcloseall();
		}
	}
}

